/* 
 * This file is part of the Echo2 Drag and Drop Extension (hereinafter "EDND").
 * Copyright (C) 2002-2005 NextApp, Inc.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

// Quirk race condition workaround to touch low level contructs before they are accessed.
Class.create();
new Element.toggle();

EchoDragAndDrop = function() {}
 
/**
 * ServerMessage process() implementation.
 */
EchoDragAndDrop.process = function(messagePartElement) {
    for (var i = 0; i < messagePartElement.childNodes.length; ++i) {
        if (messagePartElement.childNodes[i].nodeType == 1) {
            switch (messagePartElement.childNodes[i].tagName) {
            case "drop-target":
            	EchoDragAndDrop.processDropTarget(messagePartElement.childNodes[i]);
                break;
            }
        }
    }
};

EchoDragAndDrop.processDropTarget = function(dropElement) {
     var targetId = dropElement.getAttribute("target-id");
     var componentId = dropElement.getAttribute("id");
     var dragNodes = dropElement.getElementsByTagName("draggable");
     var nonDragNodes = dropElement.getElementsByTagName("undraggable");
     
     for (var i=0; i < dragNodes.length; i++) {
     	var dragNode = dragNodes[i];
     	var id = dragNode.getAttribute("id");
     	new Draggable(id, {revert:true} );
     }
     
     for (var i=0; i < nonDragNodes.length; i++) {
     	 var id = dragNode.getAttribute("id");
	     Draggables.removeObserver(id);
	 }
     
     Droppables.add(targetId, {
            		onDrop: function(element) {
            			EchoDragAndDrop.performDropAction(element,componentId);
            		}	
            		});
}

EchoDragAndDrop.performDropAction = function(dropElement, componentId) {
	var droppedId = dropElement.id;
	var propertyElement = EchoClientMessage.createPropertyElement(componentId, "drop-event");
	
	var clientMessageItemElement = EchoClientMessage.messageDocument.createElement("dropped-component");
    clientMessageItemElement.setAttribute("id", droppedId);
    propertyElement.appendChild(clientMessageItemElement);
	
	EchoDebugManager.updateClientMessage();
    EchoServerTransaction.connect();
}